          section   timer

          xdef      _t_on
          xdef      _t_off
          xdef      _t_start
          xdef      _t_stop
          xdef      _t_count
          xdef      _t_restart

_t_on
          LEA       LINKS(PC),A0
          TST.W     (A0)
          BNE.S     OK
          MOVEQ     #$1C,D0             * SMS_LPOL
          MOVE.W    D0,(A0)+
          LEA       POLLING(PC),A1
          MOVE.L    A1,4(A0)
          TRAP      #1
          BRA.S     OK

_t_off
          LEA       LINKS(PC),A0
          TST.W     (A0)
          BEQ.S     OK
          CLR.W     (A0)+
          MOVEQ     #$1D,D0             * SMS_RPOL
          TRAP      #1
          BRA.S     OK

_t_start
          LEA       COUNTER(PC),A1
          CLR.L     (A1)
          BRA.S     OK

_t_stop
          LEA       COUNTER(PC),A1
          BSET      #7,(A1)
          BRA.S     OK

_t_restart
          LEA       COUNTER(PC),A1
          BCLR      #7,(A1)
OK        MOVEQ     #0,D0
          RTS

_t_count
          LEA       COUNTER(PC),A1
          MOVE.L    (A1),D0
          RTS

POLLING   LEA       COUNTER(PC),A1
          MOVE.L    (A1),D1
          BMI.S     POLLEND
          ADDQ.L    #1,D1
          MOVE.L    D1,(A1)
POLLEND   MOVEQ     #0,D0
          RTS
  
LINKS     dc.l      0,0,0,0
COUNTER   dc.l      -1

          end
